import {
	Http
} from '../utils/newHttp.js';
export class Index extends Http {
	constructor() {
		super();
	}

	// 微信账号密码登录
	login(data) {
		return this.request({
			url: '/customer/account/customerWechartLog',
			method: 'POST',
			data: data
		});
	}

	// 获取当前用户信息
	getSelfMsg(data) {
		return this.request({
			url: '/customer/account/getSelfMsg',
			method: 'GET',
			data: data
		});
	}

	// 获取登陆验证码图片
	getLoginVerifyCodeImg(data) {
		return this.request({
			url: '/customer/account/getLoginVerifyCodeImg',
			method: 'GET',
			data: data,
			responseType: 'arraybuffer',
		});
	}

	// 删除oss文件
	ossDeleteSingle(data) {
		return this.request({
			url: '/im/oss/deleteSingle',
			method: 'GET',
			data: data
		});
	}

	// 设备列表
	equipmentPage(data) {
		return this.request({
			url: '/basic/equipment/page',
			method: 'POST',
			data: data
		});
	}

	// 获取任务的数据字典信息
	getTaskDic(data) {
		return this.request({
			url: '/task/dic',
			method: 'GET',
			data: data
		});
	}

	// 根据客户code查询客户联系人和客户地址
	selectAddressAndContact(data) {
		return this.request({
			url: '/customer/master/selectAddressAndContact',
			method: 'GET',
			data: data
		});
	}

	// 查询客户需求
	getRequestList(data) {
		return this.request({
			url: '/task/requirement/page',
			method: 'POST',
			data: data
		});
	}

	// 根据id查询客户需求详情
	getRequirementById(data) {
		return this.request({
			url: '/task/requirement/selectById',
			method: 'GET',
			data: data
		});
	}

	// 根据客户id获得设备列表
	getEquipmentList(data) {
		return this.request({
			url: '/customer/master/getEquipmentList',
			method: 'POST',
			data: data
		});
	}

	// 新增客户需求
	addRequirement(data) {
		return this.request({
			url: '/task/requirement/add',
			method: 'POST',
			data: data
		});
	}

	// 修改客户需求
	updateForWechat(data) {
		return this.request({
			url: '/task/requirement/updateForWechat',
			method: 'POST',
			data: data
		});
	}

	// 修改状态
	updateRequirementStatus(data) {
		return this.request({
			url: '/task/requirement/update/status',
			method: 'POST',
			data: data
		});
	}

	// 查询服务销售订单列表
	saleOrderPage(data) {
		return this.request({
			url: '/task/service/sale/order/page',
			method: 'POST',
			data: data
		});
	}

	// 查询服务销售订单详情
	selectOneDetail(data) {
		return this.request({
			url: '/task/service/sale/order/selectOneDetail',
			method: 'GET',
			data: data
		});
	}

	// 获取设备列表
	equipmentPage(data) {
		return this.request({
			url: '/basic/equipment/page',
			method: 'POST',
			data: data
		});
	}

	// 根据id查询东富龙设备
	equipmentSelectById(data) {
		return this.request({
			url: '/basic/equipment/selectById',
			method: 'GET',
			data: data
		});
	}

	// 查询联系人
	selectContactsList(data) {
		return this.request({
			url: '/customer/contacts/selectContactsList',
			method: 'POST',
			data: data
		});
	}

	// 查询地址
	getAddressList(data) {
		return this.request({
			url: '/customer/master/getAddressList',
			method: 'POST',
			data: data
		});
	}

	// 获取区域列表(区分国内国外)
	selectByInternational(data) {
		return this.request({
			url: '/basic/area/selectByInternational',
			method: 'GET',
			data: data
		});
	}

	// 增加客户账号申请
	accountAddApply(data) {
		return this.request({
			url: '/customer/account/apply/addApply',
			method: 'POST',
			data: data
		});
	}

	// 获取指定手机号的账号申请验证码
	getApplyVerifCode(data) {
		return this.request({
			url: '/customer/account/apply/getApplyVerifCode',
			method: 'GET',
			data: data
		});
	}

	// 通过旧密码修改账号密码
	changePwdByCommon(data) {
		return this.request({
			url: '/customer/account/changePwdByCommon',
			method: 'POST',
			data: data
		});
	}

	// 获取指定账号的修改密码验证码
	getPwdVerifCode(data,loadingTips) {
		return this.request({
			url: '/customer/account/getPwdVerifCode',
			method: 'GET',
			data: data,
			loadingTips,
		});
	}

	// 通过验证码修改账号的密码
	changePwdByVerifCode(data) {
		return this.request({
			url: '/customer/account/changePwdByVerifCode',
			method: 'POST',
			data: data
		});
	}

	// 根据客户号获取区域经理
	selectRegionalManagerByCustomerCode(data) {
		return this.request({
			url: '/basic/regional/manager/selectRegionalManagerByCustomerCode',
			method: 'GET',
			data: data
		});
	}

	// 外部区域经理配置
	regionalManager(data) {
		return this.request({
			url: '/basic/regionalExternal/manager/oneDetail',
			method: 'GET',
			data: data
		});
	}

	// 满意度评分管理分页
	taskEvaluationPage(data) {
		return this.request({
			url: '/task/satisfaction/evaluation/page',
			method: 'POST',
			data: data
		});
	}

	// 满意度评分管理页面初始化
	taskEvaluationDic(data) {
		return this.request({
			url: '/task/satisfaction/evaluation/dic',
			method: 'POST',
			data: data
		});
	}

	// 满意度评分详情
	taskEvaluationDetail(data) {
		return this.request({
			url: '/task/satisfaction/evaluation/detail',
			method: 'GET',
			data: data
		});
	}

	// 满意度评分
	taskEvaluationUpdate(data) {
		return this.request({
			url: '/task/satisfaction/evaluation/update',
			method: 'POST',
			data: data
		});
	}

	// 修改客户账号
	updateAccount(data) {
		return this.request({
			url: '/customer/account/updateAccount',
			method: 'POST',
			data: data
		});
	}

	// 客户需求页面初始化
	requirementDic(data) {
		return this.request({
			url: '/task/requirement/dic',
			method: 'GET',
			data: data
		});
	}

	// 服务工程师列表
	serviceEngineerList(data) {
		return this.request({
			url: '/task/requirement/selectById',
			method: 'GET',
			data: data
		});
	}

	// 获取客户设备列表
	customerDevicePage(data) {
		return this.request({
			url: '/basic/equipment/customer/page',
			method: 'POST',
			data: data
		});
	}

	// 根据id查询客户设备
	customerEquipmentSelectById(data) {
		return this.request({
			url: '/basic/equipment/customer/selectById',
			method: 'GET',
			data: data
		});
	}

	// 新增客户设备信息
	addCustomerEquipment(data) {
		return this.request({
			url: '/basic/equipment/customer/add',
			method: 'POST',
			data: data
		});
	}

	// 编辑客户设备信息
	editCustomerEquipment(data) {
		return this.request({
			url: '/basic/equipment/customer/updateById',
			method: 'POST',
			data: data
		});
	}

}
