// 全局配置
// mescroll-body 和 mescroll-uni 通用

import {
    initVueI18n
  } from '@dcloudio/uni-i18n'

import messages from '@/locale/index'
const { i18n } = initVueI18n(messages)

const GlobalOption = {
	down: {
		// 其他down的配置参数也可以写,这里只展示了常用的配置:
		// 下拉刷新
		textInOffset: i18n.message.textInOffset, // 下拉的距离在offset范围内的提示文本
		// 释放更新
		textOutOffset: i18n.message.textOutOffset, // 下拉的距离大于offset范围的提示文本
		// 加载中 ...
		textLoading: i18n.message.textLoading, // 加载中的提示文本
		offset: 80, // 在列表顶部,下拉大于80px,松手即可触发下拉刷新的回调
		native: false // 是否使用系统自带的下拉刷新; 默认false; 仅在mescroll-body生效 (值为true时,还需在pages配置enablePullDownRefresh:true;详请参考mescroll-native的案例)
	},
	up: {
		// 其他up的配置参数也可以写,这里只展示了常用的配置:
		// 加载中 ...
		textLoading: i18n.message.textLoading, // 加载中的提示文本
		// 已经到底啦~
		textNoMore: i18n.message.textNoMore, // 没有更多数据的提示文本
		offset: 80, // 距底部多远时,触发upCallback
		isBounce: false, // 默认禁止橡皮筋的回弹效果, 必读事项: http://www.mescroll.com/qa.html?v=190725#q25
		toTop: {
			// 回到顶部按钮,需配置src才显示
			src: "http://www.mescroll.com/img/mescroll-totop.png?v=1", // 图片路径 (建议放入static目录, 如 /static/img/mescroll-totop.png )
			offset: 1000, // 列表滚动多少距离才显示回到顶部按钮,默认1000px
			right: 20, // 到右边的距离, 默认20 (支持"20rpx", "20px", "20%"格式的值, 纯数字则默认单位rpx)
			bottom: 120, // 到底部的距离, 默认120 (支持"20rpx", "20px", "20%"格式的值, 纯数字则默认单位rpx)
			width: 72 // 回到顶部图标的宽度, 默认72 (支持"20rpx", "20px", "20%"格式的值, 纯数字则默认单位rpx)
		},
		empty: {
			use: true, // 是否显示空布局
			icon: "http://www.mescroll.com/img/mescroll-empty.png?v=1", // 图标路径 (建议放入static目录, 如 /static/img/mescroll-empty.png )
			// ~ 暂无相关数据 ~
			tip: i18n.message.noDataTitle // 提示
			// tip: '~ 暂无相关数据 ~'
		}
	}
}

export default GlobalOption
